(** Common types. *)
(* Memory info command for virtual domains.
   (C) Copyright 2008 Richard W.M. Jones, Red Hat Inc.
   http://libvirt.org/

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Common types.
 *)

module D = Libvirt.Domain

open Virt_mem_mmap

type ksym = string

module Ksymmap = Map.Make (String)

type image0 = {
  dom : Libvirt.ro D.t option;
  domname : string;
  arch : Virt_mem_utils.architecture;
  mem : ([`Wordsize], [`Endian], [`HasMapping]) Virt_mem_mmap.t;
}

type image1 =
    image0
    * addr Ksymmap.t

type image2 =
    image0
    * addr Ksymmap.t
    * utsname option

and utsname = {
  kernel_name : string;
  nodename : string;
  kernel_release : string;
  kernel_version : string;
  machine : string;
  domainname : string;
}
